// Program ShutDown.cpp
#define	STRICT
#include	<ctype.h>
#include	<stdlib.h>
#include	<string.h>
#include	<windows.h>
#include	<windowsx.h>

#define ID_REBOOT	0
#define ID_RESTART	1
#define ID_QUIT	2
#define ID_HELP	3
#define ID_CLOSE	4
#define INI_FILE	"MyIni.ini"
#define VERSION	"ShutDown ver 1.1"

char	 S[128];
char  Name[] = "ShutDown";
char	 usage[] = "\t"
			 VERSION
			 "\n\tcompiled:\n\t\t"
			 __DATE__
			 "\n\n"
			 "SHUTDOWN [/C] [/H] [/W] [/X]\n\n"
			 "\t/C\tReboots the computer\n"
			 "\t/H\tDisplays this help dialog\n"
			 "\t/W\tRestarts Windows\n"
			 "\t/X\tExits Windows\n\n"
			 "\tStarting without any parameters\n"
			 "allows you to choose at runtime.\n";

LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
void				ProcessExit(HWND, long);

int pascal		WinMain(HINSTANCE hInst,
					   HINSTANCE hPrevInstance,
					   LPSTR     lpszCmdParam,
					   int	   nCmdShow) {

  HWND		hwnd, hControl[5], hName[8];
  MSG		Msg;
  WNDCLASS	W;
  char		c;
  int		x, y;

  if (lpszCmdParam!=NULL) {
    c = tolower(lpszCmdParam[1]);
    switch (c) {
      case 'b':
	 case 'c':
      case 's':
	    ExitWindows(EW_REBOOTSYSTEM, NULL);
	   break;
      case 'r':
	 case 'w':
	    ExitWindows(EW_RESTARTWINDOWS, NULL);
	   break;
      case 'q':
	 case 'x':
	    ExitWindows(0, NULL);
	   break;
	 case 'h':
      case '?':
	    MessageBox(NULL, usage, "Shut Down Usage", MB_OK);
	    return 0;
	   break;
	 default:
	   break;
    }
  }
  x = GetPrivateProfileInt(Name, "X", CW_USEDEFAULT, INI_FILE);
  y = GetPrivateProfileInt(Name, "Y", CW_USEDEFAULT, INI_FILE);

  memset(&W, 0, sizeof(WNDCLASS));
  W.style         = CS_HREDRAW | CS_VREDRAW;
  W.lpfnWndProc   = WndProc;
  W.hInstance     = hInst;
  W.hIcon		   = LoadIcon(hInst, "ICON_1");
  W.hbrBackground = GetStockBrush(LTGRAY_BRUSH);
  W.lpszClassName = Name;
  RegisterClass(&W);

  hwnd				= CreateWindow(Name, VERSION, WS_OVERLAPPED|
					  WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,
					  x, y, 240, 164+GetSystemMetrics(SM_CYCAPTION),
					  NULL, NULL, hInst, NULL);
					 
  hName[0]			= CreateWindow("static", "Michael J. Chappell",
					  WS_VISIBLE|WS_CHILD|SS_CENTER,
					  39, 4, 160, 20,
					  hwnd, NULL, hInst, NULL);

  hName[1]			= CreateWindow("static", "JudgeWare",
					  WS_VISIBLE|WS_CHILD|SS_CENTER,
					  39, 24, 160, 20,
					  hwnd, NULL, hInst, NULL);

  hName[2]			= CreateWindow("static", "August 6, 1998",
					  WS_VISIBLE|WS_CHILD|SS_CENTER,
					  39, 44, 160, 20,
					  hwnd, NULL, hInst, NULL);

  hName[3]			= CreateWindow("static", NULL,
					  WS_VISIBLE|WS_CHILD|SS_BLACKFRAME,
					  39, 2, 160, 64,
					  hwnd, NULL, hInst, NULL);

  hName[4]			= CreateWindow("static", "ICON_1",
					  WS_VISIBLE|WS_CHILD|SS_ICON,
					  3, 18, 32, 32,
					  hwnd, NULL, hInst, NULL);

  hName[5]			= CreateWindow("static", "JW_1",
					  WS_VISIBLE|WS_CHILD|SS_ICON,
					  203, 18, 32, 32,
					  hwnd, NULL, hInst, NULL);

  hName[6]			= CreateWindow("static", NULL,
					  WS_VISIBLE|WS_CHILD|SS_BLACKFRAME,
					  2, 17, 34, 34,
					  hwnd, NULL, hInst, NULL);

  hName[7]			= CreateWindow("static", NULL,
					  WS_VISIBLE|WS_CHILD|SS_BLACKFRAME,
					  202, 17, 34, 34,
					  hwnd, NULL, hInst, NULL);

  hControl[ID_REBOOT]	= CreateWindow("button", "Reboot Computer",
					  WS_VISIBLE|WS_CHILD|BS_PUSHBUTTON|WS_TABSTOP|WS_GROUP,
					  2, 68, 164, 30,
					  hwnd, HMENU(ID_REBOOT+256), hInst, NULL);

  hControl[ID_RESTART]	= CreateWindow("button", "Restart Windows", WS_CHILD|
					  WS_VISIBLE|BS_PUSHBUTTON,
					  2, 100, 164, 30,
					  hwnd, HMENU(ID_RESTART+256), hInst, NULL);

  hControl[ID_QUIT]		= CreateWindow("button", "Shut Down Computer", WS_CHILD|
					  WS_VISIBLE|BS_PUSHBUTTON,
					  2, 132, 233, 30,
					  hwnd, HMENU(ID_QUIT+256), hInst, NULL);

  hControl[ID_HELP]		= CreateWindow("button", "Help",
					  WS_VISIBLE|WS_CHILD|BS_PUSHBUTTON|WS_TABSTOP|WS_GROUP,
					  170, 68, 66, 30,
					  hwnd, HMENU(ID_HELP+256), hInst, NULL);

  hControl[ID_CLOSE]	= CreateWindow("button", "Close", WS_CHILD|
					  WS_VISIBLE|BS_PUSHBUTTON|WS_TABSTOP|WS_GROUP,
					  170, 100, 66, 30,
					  hwnd, HMENU(ID_CLOSE+256), hInst, NULL);

  ShowWindow(hwnd, SW_SHOWMINIMIZED);
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);
  SetFocus(hControl[ID_QUIT]);

  while (GetMessage(&Msg, NULL, 0, 0))
  if (!IsDialogMessage(hwnd,&Msg))
  {
	TranslateMessage(&Msg);
	DispatchMessage(&Msg);
  }

  return Msg.wParam;
} //WinMain

LRESULT CALLBACK _export	WndProc(HWND hwnd, UINT Message,
						   WPARAM wParam, LPARAM lParam)
{
  UINT		wReturn;
  char		szMsg[80];
  char		temp[17];
  RECT		rc;

  switch (Message) {
    case WM_DESTROY:
    	if (!IsIconic(hwnd)) {
	  GetWindowRect(hwnd, &rc);
	  WritePrivateProfileString(Name, "X", itoa(rc.left, temp, 10), INI_FILE);
	  WritePrivateProfileString(Name, "Y", itoa(rc.top , temp, 10), INI_FILE);
	}
	PostQuitMessage(0);
	return 0;
     break;
    case WM_COMMAND:
	switch (wParam-256) {
	  case ID_REBOOT:
         ProcessExit(hwnd, EW_REBOOTSYSTEM);
	    break;
	  case ID_RESTART:
	    ProcessExit(hwnd, EW_RESTARTWINDOWS);
	    break;
	  case ID_QUIT:
	    ProcessExit(hwnd, 0);
	    break;
	  case ID_HELP:
	    MessageBox(NULL, usage, "Shut Down Usage", MB_OK);
	    break;
	  case ID_CLOSE:
	    if (!IsIconic(hwnd)) {
	  	GetWindowRect(hwnd, &rc);
	  	WritePrivateProfileString(Name, "X", itoa(rc.left, temp, 10), INI_FILE);
	  	WritePrivateProfileString(Name, "Y", itoa(rc.top , temp, 10), INI_FILE);
	    }
	    ShowWindow(hwnd, SW_SHOWMINIMIZED);
	    PostQuitMessage(0);
	    return 0;
	    break;
	}
     break;
  }
  return DefWindowProc(hwnd, Message, wParam, lParam);
} //WinProc

void ProcessExit(HWND hwnd, long command) {
	char		temp[17];
	RECT		rc;

	GetWindowRect(hwnd, &rc);
	WritePrivateProfileString(Name, "X", itoa(rc.left, temp, 10), INI_FILE);
	WritePrivateProfileString(Name, "Y", itoa(rc.top , temp, 10), INI_FILE);
     ShowWindow(hwnd, SW_SHOWMINIMIZED);
	ExitWindows(command, NULL);
} // ProcessExit
